SystemOrganization addCategory: #'Ma proxy support'!

ProtoObject subclass: #MaMinimalObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma proxy support'!

!MaMinimalObject methodsFor: 'printing' stamp: 'cmm 12/25/2002 00:41'!
printString
	"Answer a String whose characters are a description of the receiver. 
	If you want to print without a character limit, use fullPrintString."

	^String streamContents: [ :s | self printOn: s ]! !

!MaMinimalObject methodsFor: 'debugging' stamp: ''!
halt: aString 
	"This is the typical message to use for inserting breakpoints during 
	debugging. It creates and schedules a Notifier with the argument, 
	aString, as the label."
	
	Halt new signal: aString
! !

!MaMinimalObject methodsFor: 'actions' stamp: ''!
finalize

	^self
! !

MaMinimalObject subclass: #MaMutatingProxy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma proxy support'!

!MaMutatingProxy methodsFor: 'private actions' stamp: ''!
doesNotUnderstand: aMessage

	^self mutateAndSend: aMessage
! !

!MaMutatingProxy methodsFor: 'private creation' stamp: 'cmm 12/24/2002 16:17'!
mutant
	"subclass responsibility"! !

!MaMutatingProxy methodsFor: 'private actions' stamp: ''!
mutateAndSend: aMessage

	^self mutant
		perform: aMessage selector
		withArguments: aMessage arguments
! !

!MaMutatingProxy methodsFor: 'private actions' stamp: 'cmm 9/23/2003 01:19'!
becomeForward: otherObject copyHash: copyHash
	"Primitive. All variables in the entire system that used to point to the receiver now point to the argument.
	If copyHash is true, the argument's identity hash bits will be set to those of the recevier.
	Fails if either argument is a SmallInteger."

	(Array with: self)
		elementsForwardIdentityTo:
			(Array with: otherObject)
				copyHash: copyHash! !

!MaMinimalObject methodsFor: 'private' stamp: 'cmm 12/25/2002 00:42'!
primitiveFailed
	"Announce that a primitive has failed and there is no appropriate 
	Smalltalk code to run."

	self error: 'a primitive has failed'! !

!MaMinimalObject methodsFor: 'accessing' stamp: ''!
basicClass

	^self proxyClass
! !

!MaMinimalObject methodsFor: 'accessing' stamp: ''!
class

	^self proxyClass
! !

!MaMinimalObject methodsFor: 'Public methods' stamp: ''!
basicSize
	"Primitive. Answer the number of indexable variables in the receiver. 
	This value is the same as the largest legal subscript. Essential. Do not 
	override in any subclass. See Object documentation whatIsAPrimitive."

	<primitive: 62>
	"The number of indexable fields of fixed-length objects is 0"
	^0 ! !

!MaMinimalObject methodsFor: 'testing' stamp: ''!
maIsMinimalObject

	^true
! !

!MaMinimalObject methodsFor: 'accessing' stamp: 'cmm 12/25/2002 00:44'!
instVarAt: index 
	"Primitive. Answer a fixed variable in an object. The numbering of the 
	variables corresponds to the named instance variables. Fail if the index 
	is not an Integer or is not the index of a fixed variable. Essential. See 
	Object documentation whatIsAPrimitive."

	"Access beyond fixed variables."

	<primitive: 73>
	self primitiveFailed! !

!MaMinimalObject methodsFor: 'Public methods' stamp: ''!
= anObject 
	"Answer whether the receiver and the argument represent the same 
	object. If = is redefined in any subclass, consider also redefining the 
	message hash."

	^self == anObject! !

!MaMinimalObject methodsFor: 'printing' stamp: ''!
printOn: aStream
	"Append to the argument, aStream, a sequence of characters that  
	identifies the receiver."

	| title |
	title _ self class name.
	aStream
		nextPutAll: (title first isVowel ifTrue: ['an '] ifFalse: ['a ']);
		nextPutAll: title
! !

!MaMinimalObject methodsFor: 'accessing' stamp: ''!
proxyClass

	"Answer a Class which is the receiver's class"

	<primitive: 111>
	self primitiveFailed
! !

!MaMinimalObject methodsFor: 'actions' stamp: ''!
halt
	"This is the typical message to use for inserting breakpoints during 
	debugging. It behaves like halt:, but does not call on halt: in order to 
	avoid putting this message on the stack. Halt is especially useful when 
	the breakpoint message is an arbitrary one."

	Halt signal
! !

!MaMinimalObject methodsFor: 'actions' stamp: 'cmm 12/1/2004 14:28'!
inspect
	"Create and schedule an Inspector in which the user can examine the receiver's variables."

	self inspectorClass openOn: self withEvalPane: true
! !

!MaMinimalObject methodsFor: 'accessing' stamp: ''!
yourself

	^self
! !

!MaMinimalObject methodsFor: 'Public methods' stamp: ''!
~= anObject

	"Answer a Boolean which is false when the receiver and anObject
	 are equivalent, and true otherwise."

	^(self = anObject) not! !

!MaMinimalObject methodsFor: 'actions' stamp: ''!
error: aString

	"Stop the currently executing process and display
	 the error message aString."

	^nil error: aString
! !

!MaMinimalObject methodsFor: 'actions' stamp: 'cmm 12/1/2004 14:28'!
inspectorClass

	^ Inspector! !

!Object methodsFor: '*ma proxy support' stamp: ''!
maIsMinimalObject

	^false
! !
